Index: trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 4855)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 4870)
@@ -50,4 +50,5 @@
 #include "MStatusDisplay.h"
 
+#include "MGeomCam.h"
 #include "MHCamEvent.h"
 #include "MPedestalCam.h"
@@ -115,5 +116,5 @@
                                           MCalibrationCam &qecam,
                                           MCalibrationCam &tmcam,
-                                          MBadPixelsCam &badpix, MTask* &ext1, MTask* &ext2) const
+                                          MBadPixelsCam &badpix, MTask* &ext1, MTask* &ext2, TString &geom) const
 {
     const TString fname = Form("%s/calib%06d.root", fPathIn.Data(), fSequence.GetSequence());
@@ -148,9 +149,4 @@
 
     TObject *o = file.Get("ExtractSignal");
-//    if (!o)
-//    {
-//        *fLog << err << dbginf << "ERROR - Unable to read ExtractSignal from file " << fname << endl;
-//        return kFALSE;
-//    }
     if (o && !o->InheritsFrom(MExtractor::Class()))
     {
@@ -161,9 +157,4 @@
 
     o = file.Get("ExtractTime");
-//    if (!o)
-//    {
-//        *fLog << err << dbginf << "ERROR - Unable to read ExtractTime from file " << fname << endl;
-//        return kFALSE;
-//    }
     if (o && !o->InheritsFrom(MExtractor::Class()))
     {
@@ -172,5 +163,4 @@
     }
     ext2 = o ? (MTask*)o->Clone() : NULL;
-
     if (!ext1 && !ext2)
     {
@@ -178,4 +168,12 @@
         return kFALSE;
     }
+
+    o = file.Get("MGeomCam");
+    if (o && !o->InheritsFrom(MGeomCam::Class()))
+    {
+        *fLog << err << dbginf << "ERROR - MGeomCam read from " << fname << " doesn't inherit from MGeomCam!" << endl;
+        return kFALSE;
+    }
+    geom = o ? o->ClassName() : "";
 
     return kTRUE;
@@ -227,6 +225,7 @@
     MTask *extractor1=0;
     MTask *extractor2=0;
-
-    if (!ReadCalibration(calcam, qecam, tmcam, badpix, extractor1, extractor2))
+    TString geom;
+
+    if (!ReadCalibration(calcam, qecam, tmcam, badpix, extractor1, extractor2, geom))
         return kFALSE;
 
@@ -249,4 +248,9 @@
     else
         *fLog << inf << "No Time Extractor: ExtractTime in file." << endl;
+
+    if (!geom.IsNull())
+        *fLog << inf << "Camera geometry found in file: " << geom.ClassName() << endl;
+    else
+        *fLog << inf << "No Camera geometry found using default <MGeomCamMagic>" << endl;
 
     // This is necessary for the case in which it is not in the files
@@ -278,5 +282,7 @@
     //read.AddFiles(fnamein);
 
-    MGeomApply             apply; // Only necessary to craete geometry
+    MGeomApply             apply; // Only necessary to create geometry
+    if (!geom.IsNull())
+        apply.SetGeometry(geom);
     MBadPixelsMerge        merge(&badpix);
     MPedCalcFromLoGain     pedlo;
Index: trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.h	(revision 4855)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.h	(revision 4870)
@@ -10,4 +10,5 @@
 class MTask;
 class MParList;
+class MGeomCam;
 class MSequence;
 class MPedestalCam;
@@ -24,5 +25,6 @@
     Bool_t ReadCalibration(MCalibrationCam &calcam,
                            MCalibrationCam &qecam, MCalibrationCam &tmcam,
-                           MBadPixelsCam &badpix, MTask* &ext1, MTask* &ext2) const;
+                           MBadPixelsCam &badpix, MTask* &ext1, MTask* &ext2,
+                           TString &geom) const;
 
 public:
Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 4855)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 4870)
@@ -191,5 +191,5 @@
     : fRuns(0), fExtractor(NULL), fTimeExtractor(NULL),
       fColor(MCalibrationCam::kNONE), fDisplayType(kNormalDisplay),
-      fRelTimes(kFALSE), fDataCheck(kFALSE), fDebug(kFALSE)
+      fRelTimes(kFALSE), fDataCheck(kFALSE), fDebug(kFALSE), fGeometry("MGeomCamMagic")
 {
     fName  = name  ? name  : "MJCalibration";
@@ -1337,4 +1337,5 @@
 //   MJCalibration.UseBlindPixel: yes,no
 //   MJCalibration.UsePINDiode: yes,no
+//   MJCalibration.Geometry: MGeomCamMagic, MGeomCamECO1000
 //
 // For more details see the class description and the corresponding Getters
@@ -1360,4 +1361,5 @@
     SetUseBlindPixel(GetEnv("UseBlindPixel", IsUseBlindPixel()));
     SetUsePINDiode(GetEnv("UsePINDiode", IsUsePINDiode()));
+    SetGeometry(GetEnv("Geometry", fGeometry));
 
     return kTRUE;
@@ -1552,4 +1554,5 @@
 
     MGeomApply               apply;
+    apply.SetGeometry(fGeometry);
     MBadPixelsMerge          merge(&fBadPixels);
     MExtractPINDiode         pinext;
@@ -1682,6 +1685,13 @@
     // TOO MANY DAYS TRYING TO FIND THIS REASON!
     //
+    // There is NO BUG-REPORT! And no code has been deleted! And
+    // there is NO hint who wrote this work around and should
+    // be informed! Maybe the author of a WORKAROUND should contact
+    // the author of a class which he/she identified not working
+    // correctly instead of vice versa!
+    //
     if (fDisplay)
     {
+        /*
       if (IsUsePINDiode())
         {
@@ -1707,10 +1717,10 @@
             (MHCalibrationChargeCam*)plist.FindObject("MHCalibrationChargeCam");
           cam->DrawClone(Form("nonew %s",drawoption.Data()));
-        }
+        } */
     }
 
     DisplayResult(plist);
 
-    if (!WriteResult())
+    if (!WriteResult(plist.FindObject("MGeomCam")))
         return kFALSE;
 
@@ -1862,5 +1872,5 @@
 // - MBadPixelsCam
 //
-Bool_t MJCalibration::WriteResult()
+Bool_t MJCalibration::WriteResult(TObject *geom)
 {
     if (fPathOut.IsNull())
@@ -1925,4 +1935,16 @@
     }
     *fLog << inf << "ok." << endl;
+
+    if (!geom)
+        *fLog << warn << " - WARNING: MGeomCam... not found!" << endl;
+    {
+        *fLog << inf << " - MGeomCam..." << flush;
+        if (geom->Write()<=0)
+        {
+            *fLog << err << "Unable to write MGeomCam to " << oname << endl;
+            return kFALSE;
+        }
+        *fLog << inf << "ok." << endl;
+    }
 
     if (fRelTimes)
Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.h	(revision 4855)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.h	(revision 4870)
@@ -100,4 +100,6 @@
   Bool_t fDataCheck;                                   // Flag if the data check is run on raw data
   Bool_t fDebug;                                       // Flag if debug option is passed onto cal. classes
+
+  TString fGeometry;
   
   void   DisplayResult        ( MParList &plist );
@@ -108,5 +110,5 @@
   void   FixDataCheckHist     ( TH1D     *hist  ) const;
   
-  Bool_t WriteResult();
+  Bool_t WriteResult(TObject *geom);
   Bool_t WriteEventloop(MEvtLoop &evtloop) const;
   Bool_t WriteTasks(MTask *t1, MTask *t2) const;
@@ -142,4 +144,7 @@
   void SetDataCheckDisplay() { fDisplayType = kDataCheckDisplay; }
   void SetNormalDisplay()    { fDisplayType = kNormalDisplay;    }
+
+  // Camera Geomtry
+  void SetGeometry(const char *geom) { fGeometry = geom; }
   
   // Rel. Time